libgimpprint API Reference: color-conversion.h File Reference

Main Page | Modules | Alphabetical List | Data Structures | File List | Data Fields | Globals | Related Pages

# src/main/color-conversion.h File Reference

`#include <gimp-print/gimp-print.h>`
`#include <gimp-print/curve-cache.h>`

Go to the source code of this file.

## Data Structures
struct | color_correction_t
struct | channel_param_t
struct | color_description_t
struct | channel_depth_t
struct | lut_t
## Defines
#define | CHANNEL_K 0
#define | CHANNEL_C 1
#define | CHANNEL_M 2
#define | CHANNEL_Y 3
#define | CHANNEL_W 4
#define | CHANNEL_R 5
#define | CHANNEL_G 6
#define | CHANNEL_B 7
#define | CHANNEL_MAX 8
#define | CMASK_K (1 << CHANNEL_K)
#define | CMASK_C (1 << CHANNEL_C)
#define | CMASK_M (1 << CHANNEL_M)
#define | CMASK_Y (1 << CHANNEL_Y)
#define | CMASK_W (1 << CHANNEL_W)
#define | CMASK_R (1 << CHANNEL_R)
#define | CMASK_G (1 << CHANNEL_G)
#define | CMASK_B (1 << CHANNEL_B)
#define | CMASK_RAW (1 << CHANNEL_MAX)
#define | CMASK_NONE (0)
#define | CMASK_RGB (CMASK_R | CMASK_G | CMASK_B)
#define | CMASK_CMY (CMASK_C | CMASK_M | CMASK_Y)
#define | CMASK_CMYK (CMASK_CMY | CMASK_K)
#define | CMASK_CMYKRB (CMASK_CMYK | CMASK_R | CMASK_B)
#define | CMASK_ALL (CMASK_CMYK | CMASK_RGB | CMASK_W)
#define | CMASK_EVERY (CMASK_ALL | CMASK_RAW)
## Typedefs
typedef unsigned(* | stp_convert_t )(const stp_vars_t *vars, const unsigned char *in, unsigned short *out)
## Enumerations
enum | color_correction_enum_t { COLOR_CORRECTION_DEFAULT, COLOR_CORRECTION_UNCORRECTED, COLOR_CORRECTION_BRIGHT, COLOR_CORRECTION_ACCURATE, COLOR_CORRECTION_THRESHOLD, COLOR_CORRECTION_DESATURATED, COLOR_CORRECTION_DENSITY, COLOR_CORRECTION_RAW, COLOR_CORRECTION_PREDITHERED }
enum | color_model_t { COLOR_WHITE, COLOR_BLACK, COLOR_UNKNOWN }
enum | color_id_t { COLOR_ID_GRAY, COLOR_ID_WHITE, COLOR_ID_RGB, COLOR_ID_CMY, COLOR_ID_CMYK, COLOR_ID_KCMY, COLOR_ID_CMYKRB, COLOR_ID_RAW }
## Functions
unsigned | stpi_color_convert_to_gray (const stp_vars_t *v, const unsigned char *, unsigned short *)
unsigned | stpi_color_convert_to_color (const stp_vars_t *v, const unsigned char *, unsigned short *)
unsigned | stpi_color_convert_to_kcmy (const stp_vars_t *v, const unsigned char *, unsigned short *)
unsigned | stpi_color_convert_to_cmykrb (const stp_vars_t *v, const unsigned char *, unsigned short *)
unsigned | stpi_color_convert_raw (const stp_vars_t *v, const unsigned char *, unsigned short *)

## Define Documentation

#define CHANNEL_B 7

| Definition at line 72 of file color-conversion.h.

#define CHANNEL_C 1

| Definition at line 66 of file color-conversion.h.

#define CHANNEL_G 6

| Definition at line 71 of file color-conversion.h.

#define CHANNEL_K 0

| Definition at line 65 of file color-conversion.h. Referenced by channel_is_synthesized(), and generic_cmy_to_kcmy().

#define CHANNEL_M 2

| Definition at line 67 of file color-conversion.h.

#define CHANNEL_MAX 8

| Definition at line 73 of file color-conversion.h.

#define CHANNEL_R 5

| Definition at line 70 of file color-conversion.h.

#define CHANNEL_W 4

| Definition at line 69 of file color-conversion.h. Referenced by channel_is_synthesized().

#define CHANNEL_Y 3

| Definition at line 68 of file color-conversion.h.

#define CMASK_ALL (CMASK_CMYK | CMASK_RGB | CMASK_W)

| Definition at line 104 of file color-conversion.h.

#define CMASK_B (1 << CHANNEL_B)

| Definition at line 82 of file color-conversion.h.

#define CMASK_C (1 << CHANNEL_C)

| Definition at line 76 of file color-conversion.h.

#define CMASK_CMY (CMASK_C | CMASK_M | CMASK_Y)

| Definition at line 101 of file color-conversion.h. Referenced by channel_is_synthesized().

#define CMASK_CMYK (CMASK_CMY | CMASK_K)

| Definition at line 102 of file color-conversion.h. Referenced by channel_is_synthesized(), and stpi_compute_lut().

#define CMASK_CMYKRB (CMASK_CMYK | CMASK_R | CMASK_B)

| Definition at line 103 of file color-conversion.h.

#define CMASK_EVERY (CMASK_ALL | CMASK_RAW)

| Definition at line 105 of file color-conversion.h. Referenced by stpi_color_traditional_describe_parameter().

#define CMASK_G (1 << CHANNEL_G)

| Definition at line 81 of file color-conversion.h.

#define CMASK_K (1 << CHANNEL_K)

| Definition at line 75 of file color-conversion.h. Referenced by channel_is_synthesized(), and stpi_color_traditional_describe_parameter().

#define CMASK_M (1 << CHANNEL_M)

| Definition at line 77 of file color-conversion.h.

#define CMASK_NONE (0)

| Definition at line 99 of file color-conversion.h.

#define CMASK_R (1 << CHANNEL_R)

| Definition at line 80 of file color-conversion.h.

#define CMASK_RAW (1 << CHANNEL_MAX)

| Definition at line 83 of file color-conversion.h. Referenced by stpi_color_traditional_describe_parameter().

#define CMASK_RGB (CMASK_R | CMASK_G | CMASK_B)

| Definition at line 100 of file color-conversion.h.

#define CMASK_W (1 << CHANNEL_W)

| Definition at line 79 of file color-conversion.h.

#define CMASK_Y (1 << CHANNEL_Y)

| Definition at line 78 of file color-conversion.h.

## Typedef Documentation

typedef unsigned(* stp_convert_t)(const stp_vars_t *vars, const unsigned char *in, unsigned short *out)

| Definition at line 95 of file color-conversion.h.

## Enumeration Type Documentation

enum color_correction_enum_t

  | Enumeration values:
  COLOR_CORRECTION_DEFAULT |
  COLOR_CORRECTION_UNCORRECTED |
  COLOR_CORRECTION_BRIGHT |
  COLOR_CORRECTION_ACCURATE |
  COLOR_CORRECTION_THRESHOLD |
  COLOR_CORRECTION_DESATURATED |
  COLOR_CORRECTION_DENSITY |
  COLOR_CORRECTION_RAW |
  COLOR_CORRECTION_PREDITHERED |
Definition at line 37 of file color-conversion.h.

enum color_id_t

  | Enumeration values:
  COLOR_ID_GRAY |
  COLOR_ID_WHITE |
  COLOR_ID_RGB |
  COLOR_ID_CMY |
  COLOR_ID_CMYK |
  COLOR_ID_KCMY |
  COLOR_ID_CMYKRB |
  COLOR_ID_RAW |
Definition at line 107 of file color-conversion.h.

enum color_model_t

  | Enumeration values:
  COLOR_WHITE |
  COLOR_BLACK |
  COLOR_UNKNOWN |
Definition at line 58 of file color-conversion.h.

## Function Documentation

unsigned stpi_color_convert_raw | ( | const stp_vars_t * | v,
|  | const unsigned char * | ,
|  | unsigned short * |
| ) |

| Definition at line 2436 of file color-conversions.c. References lut_t::color_correction, COLOR_CORRECTION_ACCURATE, COLOR_CORRECTION_BRIGHT, COLOR_CORRECTION_DEFAULT, COLOR_CORRECTION_DENSITY, COLOR_CORRECTION_DESATURATED, COLOR_CORRECTION_PREDITHERED, COLOR_CORRECTION_RAW, COLOR_CORRECTION_THRESHOLD, COLOR_CORRECTION_UNCORRECTED, color_correction_t::correction, stp_get_component_data(), and stp_vars_t.

unsigned stpi_color_convert_to_cmykrb | ( | const stp_vars_t * | v,
|  | const unsigned char * | ,
|  | unsigned short * |
| ) |

| Definition at line 2414 of file color-conversions.c. References color_description_t::color_id, COLOR_ID_CMY, COLOR_ID_CMYK, COLOR_ID_GRAY, COLOR_ID_KCMY, COLOR_ID_RGB, COLOR_ID_WHITE, lut_t::input_color_description, stp_get_component_data(), and stp_vars_t.

unsigned stpi_color_convert_to_color | ( | const stp_vars_t * | v,
|  | const unsigned char * | ,
|  | unsigned short * |
| ) |

| Definition at line 2370 of file color-conversions.c. References color_description_t::color_id, COLOR_ID_CMY, COLOR_ID_CMYK, COLOR_ID_GRAY, COLOR_ID_KCMY, COLOR_ID_RGB, COLOR_ID_WHITE, lut_t::input_color_description, stp_get_component_data(), and stp_vars_t.

unsigned stpi_color_convert_to_gray | ( | const stp_vars_t * | v,
|  | const unsigned char * | ,
|  | unsigned short * |
| ) |

| Definition at line 2348 of file color-conversions.c. References color_description_t::color_id, COLOR_ID_CMY, COLOR_ID_CMYK, COLOR_ID_GRAY, COLOR_ID_KCMY, COLOR_ID_RGB, COLOR_ID_WHITE, lut_t::input_color_description, stp_get_component_data(), and stp_vars_t.

unsigned stpi_color_convert_to_kcmy | ( | const stp_vars_t * | v,
|  | const unsigned char * | ,
|  | unsigned short * |
| ) |

| Definition at line 2392 of file color-conversions.c. References color_description_t::color_id, COLOR_ID_CMY, COLOR_ID_CMYK, COLOR_ID_GRAY, COLOR_ID_KCMY, COLOR_ID_RGB, COLOR_ID_WHITE, lut_t::input_color_description, stp_get_component_data(), and stp_vars_t.